# $Id: dynamics.spec,v 1.15 2001/10/20 18:03:11 jm Exp $
Summary: Dynamics -- HUT Mobile IP (Mobile IPv4 with hierarchical tunnels)
Name: dynamics
Version: 0.8.1
Release: 1
License: GPL
Group: Networking/Daemons
Source: http://www.cs.hut.fi/Research/Dynamics/pre/dynamics-%{version}.tar.gz
Buildroot: %{_tmppath}/%{name}-root
URL: http://www.cs.hut.fi/Research/Dynamics/
Prereq: /sbin/chkconfig /sbin/service
Packager: Dynamics <dynamics@cs.hut.fi>

%description
Dynamics - HUT Mobile IP is a hierarchical tunneling system, which allows
mobile users to connect to the Internet using their own Internet address
and move under foreign networks providing tunneling support without losing
their network connections. All mobility related actions are performed
automatically by agents. All the mobile user needs to do, is to click the
connect button. The tunneling system is hierarchical and it optimizes the
time needed in location updates to switch tunnels to new location.

%package fa
Summary: Foreign Agent part of Dynamics -- HUT Mobile IP
Group: Networking/Daemons

%description fa
Foreign Agent functionality of Dynamics -- HUT Mobile IP. Mobility agent
for foreign (access) network.

%package mn
Summary: Mobile Node part of Dynamics -- HUT Mobile IP
Group: Networking/Daemons

%description mn
Mobile Node functionality of Dynamics -- HUT Mobile IP.

%package ha
Summary: Home Agent part of Dynamics -- HUT Mobile IP
Group: Networking/Daemons

%description ha
Home Agent functionality of Dynamics -- HUT Mobile IP. Mobility agent
for home network.

%package devel
Summary: Development tools for Dynamics -- HUT Mobile IP
Group: Development/Libraties

%description devel
Libraries and header files for developing applications using
Dynamics -- HUT Mobile IP API.

%prep
%setup

%build
%configure
rm doc/dynfad.8 doc/dynhad.8 doc/dynmnd.8 doc/dynamics.8
rm doc/dynfad.conf.5 doc/dynhad.conf.5 doc/dynmnd.conf.5
JFLAG=""
if [ -r /proc/cpuinfo ]; then
        NUM=`grep ^processor /proc/cpuinfo | wc -l | tr -d " "`
        if [ $NUM -gt 1 ]; then
                JFLAG="-j$NUM"
        fi
fi
make $JFLAG RPM_OPT_FLAGS="$RPM_OPT_FLAGS"

%install
[ "$RPM_BUILD_ROOT" != "/" ] && rm -rf $RPM_BUILD_ROOT
make install DESTDIR=$RPM_BUILD_ROOT 
install -d $RPM_BUILD_ROOT/etc/rc.d/init.d
install -m 755 RedHat/dynfad $RPM_BUILD_ROOT/etc/rc.d/init.d
install -m 755 RedHat/dynmnd $RPM_BUILD_ROOT/etc/rc.d/init.d
install -m 755 RedHat/dynhad $RPM_BUILD_ROOT/etc/rc.d/init.d

%clean
[ "$RPM_BUILD_ROOT" != "/" ] && rm -rf $RPM_BUILD_ROOT

%files
%doc README COPYING ChangeLog doc/dynamics_config_checklist
%doc doc/Dynamics-HUT-Mobile-IP-HOWTO doc/technical-document.txt
%doc doc/conformance.RFC doc/conformance.RFC2002 doc/conformance.RFC2344


%files fa
%{_sbindir}/dynfad
%{_sbindir}/dynfa_tool
%{_sbindir}/dynamics-fa-setup
%{_sbindir}/rsakeygen
%{_sbindir}/rsakeyhash
%{_mandir}/man8/dynfad.8*
%{_mandir}/man5/dynfad.conf.5*
%{_mandir}/man8/dynfa_tool.8*
%{_mandir}/man8/rsakeygen.8*
%config /etc/rc.d/init.d/dynfad
%config(noreplace) %attr(600,-,-) /etc/dynfad.conf

%files mn
%{_sbindir}/dynmnd
%{_sbindir}/dynmn_tool
%{_sbindir}/dynamics-mn-setup
%{_mandir}/man8/dynmnd.8*
%{_mandir}/man5/dynmnd.conf.5*
%{_mandir}/man8/dynmn_tool.8*
%config /etc/rc.d/init.d/dynmnd
%config(noreplace) %attr(600,-,-) /etc/dynmnd.conf

%files ha
%{_sbindir}/dynhad
%{_sbindir}/dynha_tool
%{_sbindir}/dynamics-ha-setup
%{_mandir}/man8/dynhad.8*
%{_mandir}/man5/dynhad.conf.5*
%{_mandir}/man8/dynha_tool.8*
%config /etc/rc.d/init.d/dynhad
%config(noreplace) %attr(600,-,-) /etc/dynhad.conf

%files devel
%dir %{_libdir}/dynamics
%{_libdir}/dynamics/libdynfa.a
%{_libdir}/dynamics/libdynha.a
%{_libdir}/dynamics/libdynmn.a
%dir %{_includedir}/dynamics
%{_includedir}/dynamics/dyn_api.h
%{_includedir}/dynamics/dyn_falib.h
%{_includedir}/dynamics/dyn_halib.h
%{_includedir}/dynamics/dyn_mnlib.h
%{_includedir}/dynamics/lib_api.h
%{_mandir}/man3/libdynfa.3*
%{_mandir}/man3/libdynha.3*
%{_mandir}/man3/libdynmn.3*


%post fa
chmod 600 %{_sysconfdir}/dynfad.conf
if [ ! -e %{_sysconfdir}/dynfad.key ] ; then
	%{_sbindir}/rsakeygen %{_sysconfdir}/dynfad.key 768
fi

if [ ! -f %{_sysconfdir}/sysconfig/network ]; then
    exit 0
fi
                
. %{_sysconfdir}/sysconfig/network   
                
[ ${NETWORKING} = "no" ] && exit 0

echo "Updating configuration files"
                
cd %{_sysconfdir}/sysconfig/network-scripts || exit 0
interfaces=`ls ifcfg* | \
        egrep -v '(ifcfg-lo|:)' | egrep 'ifcfg-[a-z0-9]+$' | \
        sed 's/^ifcfg-//g'`

IF_LIST=""
for i in $interfaces; do
	if [ ! -r "ifcfg-$i" ]; then continue; fi
        unset ONBOOT
        . ifcfg-$i
        if [ "$ONBOOT" = "yes" ] ; then IF_LIST="$IF_LIST $i"; fi
done

for i in $interfaces; do
	if [ ! -r "ifcfg-$i" ]; then continue; fi
        unset IPADDR
        . ifcfg-$i
        if [ "$IPADDR" != "" ] ; then break; fi
done

if [ -z "$IPADDR" ]; then
	echo Could not find network configuration - using defaults
	echo Please setup %{_sysconfdir}/dynfad.conf.
	exit 0
fi

echo Using following settings:

SED="s/HighestFAIPAddress 192.168.240.1/HighestFAIPAddress $IPADDR/"
SED="$SED;s/UpperFAIPAddress 192.168.240.1/UpperFAIPAddress $IPADDR/"
if [ "$IF_LIST" != "" ] ; then
	SED="$SED;s/eth0         1	   1         30/"
	FIRST=1
	for i in $IF_LIST; do
		if [ $FIRST -eq 1 ] ; then
			FIRST=0
			echo "Using interface $i for both upper and lower direction (i.e. to HAs / MNs)"
			SED="$SED$i	1	1	30"
		else
			echo "Using interface $i for lower direction (i.e. to MNs)"
			SED="$SED$i	3	1	30"
		fi
	done
	SED="$SED#eth0         1	   1         30/"
fi

HASH=`%{_sbindir}/rsakeyhash %{_sysconfdir}/dynfad.key`
SED="$SED;s/# HighestFAPubKeyHash 78439F9EA1FE32EDD8CE2028062DC96A/HighestFAPubKeyHash $HASH/"

cat %{_sysconfdir}/dynfad.conf | sed "$SED" | tr  '\n' > %{_sysconfdir}/dynfad.conf._tmp
mv -f %{_sysconfdir}/dynfad.conf._tmp %{_sysconfdir}/dynfad.conf
chmod 600 %{_sysconfdir}/dynfad.conf

echo Highest FA using IP address $IPADDR
echo Please check %{_sysconfdir}/dynfad.conf and fix the possibly incorrect values.
echo You may use command 'chkconfig --add dynfad' to make the daemon start
echo automatically at bootup time.


%preun fa
if [ "$1" = 0 ]; then
	/sbin/chkconfig --del dynfad
fi

%postun fa
if [ $1 -ge 1 ]; then
    /sbin/service dynfad condrestart >/dev/null 2>&1
fi
rm %{_sysconfdir}/dynfad.key

%post ha
chmod 600 %{_sysconfdir}/dynhad.conf

echo Please check %{_sysconfdir}/dynhad.conf and fix the possibly incorrect values.
echo You may use command 'chkconfig --add dynhad' to make the daemon start
echo automatically at bootup time.

%postun ha
if [ $1 -ge 1 ]; then
    /sbin/service dynhad condrestart >/dev/null 2>&1
fi

%preun ha
if [ "$1" = 0 ]; then
	/sbin/chkconfig --del dynhad
fi


%post mn
chmod 600 %{_sysconfdir}/dynmnd.conf

if [ ! -f %{_sysconfdir}/sysconfig/network ]; then
    exit 0
fi
                
. %{_sysconfdir}/sysconfig/network   
                
[ ${NETWORKING} = "no" ] && exit 0

echo "Updating configuration files"
                
cd %{_sysconfdir}/sysconfig/network-scripts || exit 0
interfaces=`ls ifcfg* | \
        egrep -v '(ifcfg-lo|:)' | egrep 'ifcfg-[a-z0-9]+$' | \
        sed 's/^ifcfg-//g'`
for i in $interfaces; do
	if [ ! -r "ifcfg-$i" ]; then continue; fi
        unset IPADDR NETWORK NETMASK GATEWAY
        . ifcfg-$i
        if [ -n "$IPADDR" ] ; then break; fi
done

if [ -z "$IPADDR" ]; then
	echo Could not find network configuration - using defaults
	echo Please setup %{_sysconfdir}/dynmnd.conf.
	exit 0
fi

function plen()
{
        case $1 in
                255) PLEN=8;;
                254) PLEN=7;;
                252) PLEN=6;;
                248) PLEN=5;;
                240) PLEN=4;;
                224) PLEN=3;;
                192) PLEN=2;;
                128) PLEN=1;;
                *) PLEN=0;;
        esac
}               

SUM=0           
nm1=`echo $NETMASK | cut -d . -f 1`
plen $nm1
SUM=$[$SUM+$PLEN]
nm2=`echo $NETMASK | cut -d . -f 2`
plen $nm2
SUM=$[$SUM+$PLEN]   
nm3=`echo $NETMASK | cut -d . -f 3`
plen $nm3
SUM=$[$SUM+$PLEN]
nm4=`echo $NETMASK | cut -d . -f 4`
plen $nm4
SUM=$[$SUM+$PLEN]
PREFIXLEN=$SUM
                
if [ -z "$NETWORK" ] ; then
	[ -z "$NETMASK" ] && echo "NETMASK and NETWORK not set." && exit 0
	ip1=`echo $IPADDR | cut -d . -f 1`
	ip2=`echo $IPADDR | cut -d . -f 2`
	ip3=`echo $IPADDR | cut -d . -f 3`
	ip4=`echo $IPADDR | cut -d . -f 4`
	nw1=$[$ip1 & $nm1] 
	nw2=$[$ip2 & $nm2] 
	nw3=$[$ip3 & $nm3] 
	nw4=$[$ip4 & $nm4]
	NETWORK="$nw1.$nw2.$nw3.$nw4"
else
	nw1=`echo $NETWORK | cut -d . -f 1`
	nw2=`echo $NETWORK | cut -d . -f 2`
	nw3=`echo $NETWORK | cut -d . -f 3`
	nw4=`echo $NETWORK | cut -d . -f 4`
fi

if [ -z "$GATEWAY" ] ; then
	ha4=$[$nw4+1]
	HAADDR="$nw1.$nw2.$nw3.$ha4"
else
	HAADDR=$GATEWAY
fi

SED="s/MNHomeIPAddress 192.168.242.2/MNHomeIPAddress $IPADDR/"
SED="$SED;s/HAIPAddress 192.168.242.1/HAIPAddress $HAADDR/"
SED="$SED;s/HomeNetAddr 192.168.242.0/HomeNetAddr $NETWORK/"
SED="$SED;s/HomeNetAddrPrefixLen 24/HomeNetAddrPrefixLen $PREFIXLEN/"
if [ -n "$GATEWAY" ] ; then
	SED="$SED;s/# HomeNetGateway 192.168.242.254/HomeNetGateway $GATEWAY/"
fi

cat %{_sysconfdir}/dynmnd.conf | sed "$SED" > %{_sysconfdir}/dynmnd.conf._tmp
mv -f %{_sysconfdir}/dynmnd.conf._tmp %{_sysconfdir}/dynmnd.conf
chmod 600 %{_sysconfdir}/dynmnd.conf

echo Using following settings:
echo MNHomeIPAddress $IPADDR
echo HomeNetAddr $NETWORK
echo HomeNetAddrPrefixLen $PREFIXLEN
echo HAIPAddress guessed $HAADDR
if [ -n "$GATEWAY" ] ; then
	echo HomeNetGateway $GATEWAY
fi
echo Please check %{_sysconfdir}/dynmnd.conf and fix the possibly incorrect values.
echo You may use command 'chkconfig --add dynmnd' to make the daemon start
echo automatically at bootup time.


%preun mn
if [ "$1" = 0 ]; then
	/sbin/chkconfig --del dynmnd
fi

%postun mn
if [ $1 -ge 1 ]; then
    /sbin/service dynmnd condrestart >/dev/null 2>&1
fi
