HA_HELP="Running HA with traces printed into stdout and into ha_traces.txt\n"
HA_DEBUG_HELP="Running HA with traces printed into stdout and debugs printed into ha_debugs.txt\n"
MN_HELP="Running MN with traces printed into stdout and into mn_traces.txt\n"
MN_DEBUG_HELP="Running MN with traces printed into stdout and debugs printed into mn_debugs.txt\n"
ARGUMENTS_HELP="\n ha: $HA_HELP ha-debug: $HA_DEBUG_HELP mn: $MN_HELP mn-debug: $MN_DEBUG_HELP \nFor Example: sh run_haaro.sh ha-debug"

echo Comparing the first command line argument...

case "$1" in
	"ha")
		echo $HA_HELP
		./src/ha/dynhad --fg --traces --config src/ha/dynhad.conf 2>&1 | tee ha_traces.txt
		;;
	"ha-debug")
		echo $HA_DEBUG_HELP
		./src/ha/dynhad --fg --traces --debug --config src/ha/dynhad.conf 2>&1 | tee ha_debugs.txt
		;;
	"mn")
		echo $MN_HELP
		./src/mn/dynmnd --fg --traces --config src/mn/dynmnd.conf 2>&1 | tee mn_traces.txt
		;;
	"mn-debug")
		echo $MN_DEBUG_HELP
		./src/mn/dynmnd --fg --traces --debug --config src/mn/dynmnd.conf 2>&1 | tee mn_debugs.txt
		;;
	"help")
		echo "help: Run the script with one of the following arguments: $ARGUMENTS_HELP"
		;;
	"")
		echo "Possible arguments: $ARGUMENTS_HELP"
		;;
	*)
		echo "Unknown argument! Possible arguments: $ARGUMENTS_HELP"
		;;
esac
