/* $Id: rsa_dyn.h,v 1.4 2000/07/21 15:17:48 ban Exp $
 * Dynamics RSA function interface
 *
 * Dynamic hierarchial IP tunnel
 * Copyright (C) 1998-2000, Dynamics group
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License version 2 as
 * published by the Free Software Foundation. See README and COPYING for
 * more details.
 */

#ifndef RSA_DYN_H
#define RSA_DYN_H

int rsa_initialize(char const *key_file);
unsigned char* rsa_encrypt_session_key(unsigned char const *session_key,
				       int sk_len,
				       unsigned char const *public_key,
				       unsigned int public_key_len,
				       unsigned int *encrypted_len);
int rsa_decrypt_session_key(unsigned char const *encrypted_key,
			    unsigned int encrypted_key_len,
			    unsigned char *session_key, int sk_len);
unsigned int rsa_get_public_key_len(void);
unsigned char const *rsa_get_public_key(void);
int rsa_make_key(char const *key_file, int bits);
void rsa_debug_print_host_key(void);

#endif
