/* $Id: sha_utils.h,v 1.2 2000/04/06 07:26:53 jm Exp $
 * Surrogate Home Agent help routines
 *
 * Dynamic hierarchial IP tunnel
 * Copyright (C) 2000, Dynamics group
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License version 2 as
 * published by the Free Software Foundation. See README and COPYING for
 * more details.
 */

#ifndef SHA_UTILS_H
#define SHA_UTILS_H

#ifdef HAVE_CONFIG_H
#include <config.h>
#endif

#include "list.h"

int eliminate_binding_entry(struct node *node, void *data);
int eliminate_binding_entry_force(struct node *node, void *data);
void check_bindings(struct bindingtable *bhash, struct hashtable *thash,
		    int *bindingcount, time_t now);
struct bindingentry *make_new_binding(struct bindingtable *bhash,
				      struct msg_extensions *ext,
				      struct sockaddr_in *addr,
				      int max_lifetime);
void check_unconfirmed_timeout(struct bindingentry *binding);
int update_binding(struct bindingtable *hash, struct bindingentry *binding,
		   int *count);
int send_address_ok(struct in_addr to_addr);

#endif
